100 REMark convert ASCII Archive Export file to ASCII Z88 Pipedream database files ready to upload (NB Set CR translate to ON in QZ file transfer)
110 REMark the fields/columns in Pipedream separated by TAB characters, code 9
120 REMark the end of line codes should be LF (10) only, translated on transfer using QZ
130 IF COMPILED THEN 
140  OPEN#0,'con_484x42a14x214':OPEN#1,'scr_484x202a14x13'
150  WHEN_ERROR 0
160   BEEP 5000,70:PRINT#0,'Oops, error ';ERNUM%;' at line ';ERLIN%
170   PRINT#0,'PRESS ANY KEY TO CONTINUE.':PAUSE
180   PRINT#0,'Retry (y/n)?';:IF YN$=='y' THEN RETRY:ELSE STOP:END IF 
190  END_WHEN
200 END IF 
210 DIM z88$(40),ql$(40),ip$(1024),op$(1024),f$(255),entry$(255),k$(2):k$=''
220 MODE 4:WINDOW#0,484,42,14,214:WINDOW 484,202,14,13
230 BORDER#0,1,4:BORDER 1,4
240 PAPER 0:INK 7:CLS:PAPER#0,0:INK#0,7:CLS#0:CURSOR_ON#0!
250 OVER 1:CSIZE 3,1:x=0
260 FOR char=2,2,2,7:CURSOR 78+x,33+(x/1.5):INK char:PRINT'ARCHIVE TO PIPEDREAM':x=x+1
270 FOR char=2,2,2,7:CURSOR 86+x,88+(x/1.5):INK char:PRINT'DATAFILE CONVERSION':x=x+1
280 FOR char=2,2,2,7:CURSOR 38+x,143+(x/1.5):INK char:PRINT'BY DILWYN JONES JUNE 1988':x=x+1
290 PRINT#0,'CONVERT QL ARCHIVE EXPORT FORMAT TO ASCII PIPEDREAM FILE'
300 CSIZE 0,0
310 REPeat loop
320  PRINT#0,'Enter filename to convert:';:TYPE_IN FILL$(CHR$(192),4)
330  z88$=EDIT$(#0,'flp1__exp',40):CURSOR_ON#0!
340  IF z88$='' THEN EXIT loop
350  z88_fer=DEVICE_STATUS(1,z88$)
360  IF z88_fer<0 THEN BEEP 5000,70:PRINT#0,"Can't load that file!":NEXT loop
370  EXIT loop
380 END REPeat loop
390 IF z88$='' THEN PRINT#0,\'End of program.':STOP
400 OPEN_IN#3,z88$
410 REPeat loop
420  PRINT#0,'Enter output filename:';:TYPE_IN FILL$(CHR$(192),4)
430  ql$=EDIT$(#0,'flp1__z88',40):CURSOR_ON#0!
440  IF ql$='' THEN EXIT loop
450  ql_fer=DEVICE_STATUS(ql$)
460  IF ql_fer=-8 THEN 
470   BEEP 5000,70:PRINT#0,'Already exists. Delete (y/n)?';
480   IF YN$=='y' THEN DELETE ql$:ql_fer=DEVICE_STATUS(ql$):ELSE NEXT loop:END IF 
490  END IF 
500  IF ql_fer<0 THEN BEEP 5000,70:PRINT#0,"Can't save that file!":NEXT loop
510  EXIT loop
520 END REPeat loop
530 IF ql$='' THEN PRINT#0,\'End of program.':STOP
540 OPEN_NEW#4,ql$
550 PRINT#0,'Reflect to screen (y/n)?';:ref_scr=(YN$=='y')
560 CLS#0:PRINT#0,'Converting ';z88$!'to'!ql$;'...'
570 in_quotes%=0
580 REMark very slow byte by byte conversion as I haven't got around to doing it line by line (same speed as Z88-Archive) yet!
590 REMark basically, just strip quotes and translate comma separators to TAB (CHR$ 9's), keeping LF at end of line
600 REMark first line of Archive export file holding field names will come out as first line of Pipedream document, including the $ text field names, though all text/numbers are translated as text for Pipedream
610 records=0:IF ref_scr THEN CLS
620 REPeat translate_data
630  IF EOF(#3) OR INKEY$=CHR$(27) THEN EXIT translate_data
640  ip$=INKEY$(#3):IF ip$=CHR$(26) THEN EXIT translate_data:REMark export file EOF marker
650  IF ip$=CHR$(10) THEN records=records+1:PRINT#4,:IF ref_scr THEN PRINT:END IF :NEXT translate_data:END IF :REMark end of line
660  IF ip$=',' AND in_quotes%=0 THEN PRINT#4,CHR$(9);:IF ref_scr THEN PRINT CHR$(9);:END IF :NEXT translate_data:END IF 
670  IF ip$='"' THEN in_quotes%=NOT in_quotes%:NEXT translate_data
680  PRINT#4,ip$;:IF ref_scr THEN PRINT ip$;
690 END REPeat translate_data
700 CLOSE#3:CLOSE#4:PRINT#0,\records;' records (including heading) converted, end of program.'
710 STOP
720 DEFine FuNction YN$
730  LOCal k$(2),loop
740  REPeat loop
750   k$=INKEY$(-1):IF k$='Y' THEN k$='y'
760   IF k$='N' THEN k$='n'
770   IF k$='y' OR k$='n' THEN PRINT#0,k$:EXIT loop
780  END REPeat loop:RETurn k$
790 END DEFine YN$
